Status: Closed   
Assignee:    

Target version:    

Description

According to Hash#slice, I would like to add Hash#except. Same for ENV.except.

Related issues:

Related to Ruby - Feature #13563: Implement Hash#choice method. Closed

Is duplicate of Ruby - Feature #8499: Importing Hash#slice, Hash#slice!, Hash... Closed

Associated revisions

Revision 82ca8c73034b0a522fd2970ea39edfcd801955fe - 06/18/2020 01:47 PM - timoschilling (Timo Schilling)

Add Hash#except ENV#except [Feature #15822]

Revision 82ca8c73034b0a522fd2970ea39edfcd801955fe - 06/18/2020 01:47 PM - timoschilling (Timo Schilling)

Add Hash#except ENV#except [Feature #15822]

Revision 82ca8c73 - 06/18/2020 01:47 PM - timoschilling (Timo Schilling)

Add Hash#except ENV#except [Feature #15822]

Revision 50c13eb718d961c333ac832e734dae21ca7a8330 - 06/18/2020 02:09 PM - nobu (Nobuyoshi Nakada)

NEWS about Hash#except ENV#except [Feature #15822]

Revision 50c13eb718d961c333ac832e734dae21ca7a8330 - 06/18/2020 02:09 PM - nobu (Nobuyoshi Nakada)

NEWS about Hash#except ENV#except [Feature #15822]

Revision 50c13eb7 - 06/18/2020 02:09 PM - nobu (Nobuyoshi Nakada)

NEWS about Hash#except ENV#except [Feature #15822]

Revision 0d3dc2ec807c313d0952d15ac4f30bc8586bba2f - 12/19/2020 08:59 AM - Marc-Andre Lafortune 

Make Hash#except always return a Hash

[Feature #15822]

Revision 0d3dc2ec807c313d0952d15ac4f30bc8586bba2f - 12/19/2020 08:59 AM - Marc-Andre Lafortune 

Make Hash#except always return a Hash

[Feature #15822]

Revision 0d3dc2ec - 12/19/2020 08:59 AM - Marc-Andre Lafortune 

Make Hash#except always return a Hash

[Feature #15822]

History

#1 - 05/05/2019 03:37 AM - nobu (Nobuyoshi Nakada)

- Is duplicate of Feature #8499: Importing Hash#slice, Hash#slice!, Hash#except, and Hash#except! from ActiveSupport added

#2 - 05/06/2019 06:25 PM - timoschilling (Timo Schilling)

- File deleted (hash-except.patch)
#3 - 05/06/2019 06:26 PM - timoschilling (Timo Schilling)

- File hash-except.patch added

#4 - 10/17/2019 06:34 AM - matz (Yukihiro Matsumoto)

- Related to Feature #13563: Implement Hash#choice method. added

#5 - 10/17/2019 06:42 AM - matz (Yukihiro Matsumoto)

Hash#slice was introduced via discussion in #13563. We didn't see the need for Hash#except yet. Any (real world use-case)?

I don't think the name except is the best name for the behavior.

Matz.

#6 - 10/17/2019 02:32 PM - zverok (Victor Shepelev)

@matz (Yukihiro Matsumoto) About use-cases, there are multiple, like:

Logging/debug printing some hash with sensitive or too large data excluded:

puts "REQUEST: #{request_data.except(:body, :apikey)}

Data tidying:

CSV.read('data.csv', headers: true).map(&:to_h).map { |row| OpenStruct.new(row.except("Manager comment")) 

}

Data conversion:

paragraphs.map { |para| ParaStats.new(para.to_h.except(:text)) }

...and so on (without even mentioning working with models in Rails, where it is used extensively to, for example, copy model without its id and

timestamps).

Redmine's sources, for example, make some use of it:

$ grep -F ".except(" {app,lib} -r | wc -l

27

 I recently stumbled upon it, too.

About the name: I understand "ActiveSupport uses this name" is kinda lazy one, but it does :) And, TBH, for me (even before I started working with

Rails, I used Ruby for first my 12 years without ActiveSupport) it always felt natural: request.except(:path, :body) requires no further explanations.

Facets uses the name, too.

The alternative method name I can think of is, maybe, descriptive without_keys(*keys) (or except_keys, or just without(*keys)), but I am not sure it is

any better.

#7 - 06/18/2020 08:46 AM - matz (Yukihiro Matsumoto)

You have provided the use-case, and I understand the need.  It's tempting the name exclude but except is OK too.

Accepted.

Matz.

#8 - 06/18/2020 01:47 PM - timoschilling (Timo Schilling)

- Status changed from Open to Closed

Applied in changeset git|82ca8c73034b0a522fd2970ea39edfcd801955fe.

Add Hash#except ENV#except [Feature #15822]

#9 - 12/17/2020 07:47 PM - marcandre (Marc-Andre Lafortune)

I think except should always return a Hash, since Matz prefers returning the base class instead of subclass and we're changing a bunch of String

methods too.

I will merge https://github.com/ruby/ruby/pull/3929 in a day or two unless there's an objection.

Files

hash-except.patch 4.05 KB 05/06/2019 timoschilling (Timo Schilling)
